Name: mailman
Version: 2.1.1
Release: alt1
Epoch: 3

%define contentdir /var/www
%define httpdconfdir %_sysconfdir/httpd/conf/addon-modules
%define www_user apache
%define mail_user postman
%define mail_group postman
%define mail_gid 48
%define crontabdir /etc/cron.d

%define _prefix /usr/share/%name
%define _exec_prefix /usr/lib/%name
%define _var_prefix %_localstatedir/%name

Summary: Mailing list manager with built in web access
License: GPL
Group: System/Servers
Url: http://www.list.org/

# http://prdownloads.sourceforge.net/%name/%name-%version.tar.bz2
Source: %name-%version.tgz
Source1: mm_cfg.py
Source2: %name-INSTALL
Source3: %name-httpd.conf
Source4: %name.logrotate
Source5: %name.crontab
Source6: %name.init

Patch1: %name-2.1-alt-configure.patch
Patch2: %name-2.1-alt-makefile.patch
Patch3: %name-2.1-alt-defaults.patch

Patch4: %name-2.1-alt-postfix.patch
Patch5: %name-2.1-alt-base64.patch

PreReq: mktemp >= 1:1.3.1, setup >= 2.2.0-alt3, shadow-utils, sendmail-common, vixie-cron
Requires: webserver, python = %__python_version

BuildPreReq: setup >= 2.2.0-alt3

# Automatically added by buildreq on Wed Feb 13 2002
BuildRequires: python

%description
Mailman, the GNU Mailing List Management System, is a mailing list
management system written mostly in Python. Features:
- Web based list administration for nearly all tasks.  Web based            
  subscriptions and user configuration management.  A customizable          
  "home page" for each mailing list.                                        
- Privacy features such as moderation, open and closed list                 
  subscription policies, private membership rosters, and                    
  sender-based filters.                                                     
- Automatic web based archiving built-in with support for private           
  and public archives, and hooks for external archivers.                    
- Per-user configuration optional digest delivery for either                
  MIME-compliant or RFC 1153 style "plain text" digests.                    
- Integrated mail/Usenet gateways.                                          
- Integrated auto-replies.                                                  
- Majordomo-style email based commands.                                     
- Integrated bounce detection within an extensible framework.               
- Integrated spam detection, and MIME-based content filtering.              
- An extensible mail delivery pipeline.                                     
- Support for virtual domains.                                              

See the Mailman home site for current status, including new releases
and known problems: %url

%prep
%setup -q
cp -p %SOURCE2 INSTALL
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
# These user/group names must be present while configure.
for n in %name %mail_group; do
	%__grep -qs "^$n:" /etc/group
done
for n in %name %www_user; do
	%__grep -qs "^$n:" /etc/passwd
done

# Special check for postman group.
%__grep -qs '^%mail_group:[^:]*:%mail_gid:' /etc/group

autoconf
%configure \
	--with-var-prefix=%_var_prefix \
	--with-python=%__python \
	--with-mail-gid=%mail_group \
	--with-cgi-id=%www_user \
	--with-cgi-gid=%www_user \
	--with-mailhost=localhost.localdomain \
	--with-urlhost=localhost.localdomain

cp -p %SOURCE1 Mailman/mm_cfg.py
%make_build OPT="$RPM_OPT_FLAGS"

%install
find Mailman -type f -print0 |
	xargs -r0 %__grep -fZl '/usr/local/bin/python' |
	xargs -r0 %__perl -pi -e 's|/usr/local/bin/python|%__python|g'

%make_install install \
	prefix=$RPM_BUILD_ROOT%prefix \
	exec_prefix=$RPM_BUILD_ROOT%_exec_prefix \
	var_prefix=$RPM_BUILD_ROOT%_var_prefix

chmod -R go-w $RPM_BUILD_ROOT{%prefix,%_exec_prefix}
find $RPM_BUILD_ROOT{%prefix,%_exec_prefix} -type d -print0 |
	xargs -r0 chmod a-s,o-r
chmod a-s,go-r $RPM_BUILD_ROOT%_var_prefix

# Create directories we'll use for log and spool files. Create links
%__install -d -m2770 $RPM_BUILD_ROOT%_spooldir/%name
%__install -d -m2771 $RPM_BUILD_ROOT{%_logdir/%name,%_spooldir/%name/qfiles}
rmdir $RPM_BUILD_ROOT%_var_prefix/{logs,qfiles}
ln -s ../../log/%name $RPM_BUILD_ROOT%_var_prefix/logs
ln -s ../../spool/%name $RPM_BUILD_ROOT%_var_prefix/qfiles

# Copy the icons into the web server's icons directory.
%__mkdir_p $RPM_BUILD_ROOT%contentdir
%__mv $RPM_BUILD_ROOT%prefix/icons $RPM_BUILD_ROOT%contentdir/

# Install a logrotate control file.
%__install -pD -m644 $RPM_SOURCE_DIR/%name.logrotate \
	$RPM_BUILD_ROOT/%_sysconfdir/logrotate.d/%name

# Install the httpd configuration file.
%__install -pD -m644 /dev/null $RPM_BUILD_ROOT%httpdconfdir/%name.conf
sed -e 's|@CODEDIR@|%_exec_prefix|g;s|@DATADIR@|%_var_prefix|g' \
	$RPM_SOURCE_DIR/%name-httpd.conf > \
	$RPM_BUILD_ROOT%httpdconfdir/%name.conf

# Install crontab file
%__install -pD -m644 %SOURCE5 $RPM_BUILD_ROOT%crontabdir/%name

# Install init script
%__install -pD -m755 %SOURCE6 $RPM_BUILD_ROOT%_initdir/%name

# Install config files for postfix
%__install -pD -m644 /dev/null $RPM_BUILD_ROOT%_var_prefix/data/aliases
%__install -pD -m644 /dev/null $RPM_BUILD_ROOT%_var_prefix/data/virtual-mailman

# External library 'email-2.4.3' by Barry Warsaw <barry@zope.com>
# Fix for unparsed base64 strings
pushd $RPM_BUILD_ROOT/usr/share/%name
patch -p0 < %PATCH5
popd

%pre
# Special check for postman group.
if ! %__grep -qs '^%mail_group:[^:]*:%mail_gid:' /etc/group ; then
	echo 'The %name package have been compiled with mail group "%mail_group", gid=%mail_gid'
	echo 'Please correct your system settings (/etc/group) and try to install %name package again'
	exit 1
fi
# Special check for postman user.
if %__grep -qs '^%mail_user:' /etc/passwd && ! %__grep -qs '^%mail_user:[^:]*:[^:]*:%mail_gid:' /etc/passwd; then
	echo 'The %name package have been compiled with mail user "%mail_user", gid=%mail_gid'
	echo 'Please correct your system settings (/etc/passwd) and try to install %name package again'
	exit 1
fi
/usr/sbin/useradd -s /dev/null -c "GNU Mailing List Manager" -d %_var_prefix -M -r -u 41 %name &>/dev/null ||:

%post
NEWALIASES=
if ! %__grep -qs '^%name:' /etc/aliases; then
	echo '%name: postmaster' >>/etc/aliases
	NEWALIASES=1
fi
if ! %__grep -qs '^%name-owner:' /etc/aliases; then
	echo '%name-owner: %name' >>/etc/aliases
	NEWALIASES=1
fi
[ -n "$NEWALIASES" ] && /usr/bin/newaliases &>/dev/null ||:
if [ -f /var/spool/cron/%name ]; then
	echo "Mailman's crontab was replaced by new file."
	crontab -u %name -r
fi
/sbin/service httpd condrestart ||:
postalias /var/lib/mailman/data/aliases
postmap /var/lib/mailman/data/virtual-mailman
echo "Please modify your /etc/postfix/main.cf file like this:"
echo "alias_maps = hash:/etc/postfix/aliases,hash:/var/lib/mailman/data/aliases"
echo "alias_database = hash:/etc/postfix/aliases,hash:/var/lib/mailman/data/aliases"
echo "alias_database = hash:/etc/postfix/virtual,hash:/var/lib/mailman/data/virtual-mailman"

%postun
if [ $1 = 0 ]; then
	SAVED=`mktemp /etc/aliases.XXXXXX`
	TMPFILE=`mktemp /etc/aliases.XXXXXX`
	%__grep -E -v '%name aliases|%name:|%name-owner:' /etc/aliases >"$TMPFILE"
	cat /etc/aliases >"$SAVED"
	cat "$TMPFILE" >/etc/aliases
	rm -f "$SAVED" "$TMPFILE"
	/usr/bin/newaliases &>/dev/null ||:
fi
%postun_service mailman
/sbin/service httpd condrestart ||:

%files
%config(noreplace) %_sysconfdir/logrotate.d/%name
%config(noreplace) %httpdconfdir/%name.conf
%config(noreplace) %crontabdir/%name
%contentdir/icons/*
%doc ACKNOWLEDGMENTS BUGS FAQ INSTALL NEWS README* TODO UPGRADING

%defattr(-,root,%name,-)
%dir %prefix
%config %prefix/Mailman
%config(noreplace) %prefix/templates
%config(noreplace) %_var_prefix/data/aliases
%config(noreplace) %_var_prefix/data/virtual-mailman
%prefix/bin
%prefix/cron
%prefix/messages
%prefix/pythonlib
%prefix/scripts
%prefix/tests
%attr(0755,root,root) %_initdir/%name
%_exec_prefix
%_var_prefix
%_logdir/%name
%_spooldir/%name

%changelog
* Mon Feb 10 2003 Igor Muratov <migor@altlinux.ru> 3:2.1.1-alt1
- build new version
- Closed a cross-site scripting vulnerability in the user options page.
- Restore the ability to control which headers show up in messages
  included in plaintext and MIME digests. See the variables
  PLAIN_DIGEST_KEEP_HEADERS and MIME_DIGEST_KEEP_HEADERS in
  Defaults.py.
- Messages included in the plaintext digests are now sent through
  the scrubber to remove (and archive) attachments.  Otherwise,
  attachments would screw up plaintext digests. MIME digests
  include the attachments inline.

* Tue Feb 06 2003 Igor Muratov <migor@altlinux.ru> 3:2.1-alt1
- build new version
- Added initscript
- Added symlink to logs
- Added symlink to spool
- Moved httpd addon config to /etc/httpd/conf/addon-modules/
- Moved crontab to /etc/cron.d
- Removed symlink /etc/smrsh/wrapper
- Patch for postfix virtual maps
- Patch for email library

* Mon Nov 18 2002 Rider <rider@altlinux.ru> 3:2.0.13-alt2
- rebuild

* Thu Aug 15 2002 Dmitry V. Levin <ldv@altlinux.org> 3:2.0.13-alt1
- 2.0.13
- Relocated log directory from %_var_prefix/logs to %_logdir/%name.
- Relocated queue directory from %_var_prefix/qfiles to %_spooldir/%name/qfiles.
- Added logrotate script.
- Added %httpdconfdir/%name.conf, updated INSTALL instructions.
- Added more READMEs.

* Fri Aug 09 2002 Dmitry V. Levin <ldv@altlinux.org> 3:2.0.12-alt2
- Rebuilt to fix perms.

* Wed Jul 17 2002 Dmitry V. Levin <ldv@altlinux.org> 3:2.0.12-alt1
- 2.0.12

* Thu May 23 2002 Dmitry V. Levin <ldv@altlinux.org> 3:2.0.11-alt1
- 2.0.11

* Tue Apr 30 2002 Dmitry V. Levin <ldv@alt-linux.org> 3:2.0.10-alt1
- 2.0.10
- Added one more check for postman user.

* Thu Apr 04 2002 Dmitry V. Levin <ldv@alt-linux.org> 3:2.0.9-alt1
- Updated code to 2.0.9
- Set explicit versioned provides on setup which defines group "postman".
- Added special check for postman group at %%pre stage.

* Wed Feb 13 2002 Dmitry V. Levin <ldv@alt-linux.org> 3:2.0.8-alt5
- Changed mail_group from nobody to postman (#0000607).
- Set explicit versioned dependence on postfix.
- Set more strict permissions on %prefix and %_exec_prefix subdirectories.

* Tue Jan 29 2002 Stanislav Ievlev <inger@altlinux.ru> 3:2.0.8-alt4
- rebuilt with new python

* Thu Dec 13 2001 Dmitry V. Levin <ldv@alt-linux.org> 3:2.0.8-alt1
- 2.0.8 (security fix release to prevent cross-site scripting exploits.)

* Thu Nov 15 2001 Dmitry V. Levin <ldv@alt-linux.org> 3:2.0.7-alt1
- 2.0.7

* Wed Jun 27 2001 Stanislav Ievlev <inger@altlinux.ru> 2.0.5-alt3
- Rebuilt with python-2.1

* Mon May 07 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.0.5-alt2
- Fixed broken symlink /etc/smrsh/wrapper (#27).

* Mon May 07 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.0.5-alt1
- 2.0.5

* Thu Apr 26 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.0.4-alt1
- 2.0.4
- Updated install hints.

* Tue Mar 13 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.0.3-ipl1
- 2.0.3

* Fri Mar 09 2001 Dmitry V. Levin <ldv@fandra.org> 2.0.2-ipl1
- 2.0.2
- Enhanced FHSification.

* Fri Feb 02 2001 Dmitry V. Levin <ldv@fandra.org> 2.0.1-ipl2
- Fixed %%post script.

* Tue Jan 09 2001 Dmitry V. Levin <ldv@fandra.org> 2.0.1-ipl1
- 2.0.1

* Sat Dec 16 2000 Dmitry V. Levin <ldv@fandra.org> 2.0-ipl2
- Updated description (MDK).
- Patched Defaults.py.
- Rebuild with new brp-python policy.

* Thu Nov 23 2000 Dmitry V. Levin <ldv@fandra.org> 2.0-ipl1
- 2.0 release.

* Thu Sep 28 2000 Dmitry V. Levin <ldv@fandra.org> 2.0beta6-ipl1
- 2.0beta6.

* Thu Sep 07 2000 Dmitry V. Levin <ldv@fandra.org> 2.0beta5-ipl1
- RE adaptions

* Thu Aug  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- add note about adding FollowSymlinks so that archives work

* Wed Aug  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- make the default owner root again so that root owns the docs
- update to 2.0beta5, which fixes a possible security vulnerability
- add smrsh symlink

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta4
- change uid/gid to apache.apache to match apache (#13593)
- properly recompile byte-compiled versions of the scripts (#13619)
- change mailman alias from root to postmaster

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta3
- drop bugs and arch patches (integrated into beta3)

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- move web files to reside under %contentdir
- move files from /usr/share to %%_datadir
- integrate spot-fixes from mailman lists via gnome.org

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild for Power Tools

* Wed May 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- Update to 2.0beta2 to pick up security fixes.
- Change Requires: python to list >= 1.5.2

* Mon Nov  8 1999 Bernhard Rosenkrnzer <bero@redhat.com>
- 1.1

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- 1.0 final.

* Tue Jun 15 1999 Preston Brown <pbrown@redhat.com>
- security fix for cookies
- moved to /usr/share/mailman

* Fri May 28 1999 Preston Brown <pbrown@redhat.com>
- fix up default values.

* Fri May 07 1999 Preston Brown <pbrown@redhat.com>
- modifications to install scripts

* Thu May 06 1999 Preston Brown <pbrown@redhat.com>
- initial RPM for SWS 3.0
